#ifndef DYNAMIC_KALMAN_FILTER_HPP
#define DYNAMIC_KALMAN_FILTER_HPP
#include <sta/math/linalg/matrix.hpp>

namespace math
{

struct KalmanState
{
	matrix error;
	matrix x;
};

class DynamicKalmanFilter
{
private:
	matrix A_;
	matrix T_;
	matrix B_;
	matrix C_;
	matrix Q_;
	matrix R_;
	uint8_t n_;
	matrix identity_;



public:
	DynamicKalmanFilter(matrix, matrix, matrix, matrix, matrix, matrix);
	~DynamicKalmanFilter();
	KalmanState predict(float, KalmanState, matrix);
	KalmanState correct(KalmanState, matrix);
};
    

    
}

#endif // DYNAMIC_KALMAN_FILTER_HPP
